//
//  FHFacebookPageTests.m
//  FirehoseCocoa
//
//  Created by Adam Kirk on 2/2/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import <XCTest/XCTest.h>
#import "FirehoseCocoa.h"
#import "MTFaker.h"
#import "FHClient.h"
#import "macros.h"


@interface FHFacebookPageTests : XCTestCase
@property (nonatomic, strong) FHAgent        *agent;
@property (nonatomic, strong) FHCompany      *company;
@property (nonatomic, strong) FHFacebookPage *facebookPage;
@end


@implementation FHFacebookPageTests


+ (void)setUp
{
    [[FHClient sharedClient] setEnvironment:ENV_ENUM];
}


- (void)setUp
{
    _agent = next_test_agent();
    _company = [_agent.companies lastObject];

    FHRemoteArray *facebookAccounts = _company.facebookAccounts;
    MTPocketRequest *request = [facebookAccounts next];

    __block MTPocketResponse *resp  = nil;
    [request sendWithSuccess:^(MTPocketResponse *response) {
        resp = response;
    } failure:^(MTPocketResponse *response) {
        resp = response;
    }];

    STALL(resp == nil)
    XCTAssertTrue(resp.success);

    FHFacebookAccount *facebookAccount = [facebookAccounts lastObject];
    _facebookPage = [facebookAccount.facebookPages lastObject];
}

- (void)testUpdate
{
    _facebookPage.active = !_facebookPage.isActive;
    MTPocketRequest *request = [_facebookPage save];

    __block MTPocketResponse *resp  = nil;
    [request sendWithSuccess:^(MTPocketResponse *response) {
        resp = response;
    } failure:^(MTPocketResponse *response) {
        resp = response;
    }];

    STALL(resp == nil)
    XCTAssertTrue(resp.success);
    XCTAssertTrue(resp.status == MTPocketStatusNoContent);
}


@end









