//
//  constants.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/12/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#define STALL(c) while (c) { [[NSRunLoop currentRunLoop] runMode:NSDefaultRunLoopMode beforeDate:[NSDate dateWithTimeIntervalSinceNow:0.5]]; }


static inline void login_agent(FHAgent *agent)
{
    MTPocketRequest *request = [agent login];

    __block MTPocketResponse *resp  = nil;
    [request sendWithSuccess:^(MTPocketResponse *response) {
        resp = response;
    } failure:^(MTPocketResponse *response) {
        resp = response;
    }];

    STALL(resp == nil)

    if (!resp.success) [NSException raise:@"Login of testing agent failed" format:@"%@", agent];
}

static inline FHAgent *next_test_agent()
{
    NSString *path = [NSTemporaryDirectory() stringByAppendingPathComponent:@"test_counter.txt"];
    int n = 1;
    if ([[NSFileManager defaultManager] fileExistsAtPath:path]) {
        NSDictionary *attributes = [[NSFileManager defaultManager] attributesOfItemAtPath:path error:nil];
        if ([[NSDate date] timeIntervalSinceDate:attributes[NSFileModificationDate]] > 10) {
            [[NSFileManager defaultManager] removeItemAtPath:path error:nil];
        }
        else {
            n = [[NSString stringWithContentsOfFile:path encoding:NSUTF8StringEncoding error:nil] intValue];
        }
    }
    FHAgent *agent = [FHAgent agentWithEmail:[NSString stringWithFormat:@"agent%d@example.com", n++] password:@"pw"];
    [[NSString stringWithFormat:@"%d", n] writeToFile:path atomically:YES encoding:NSUTF8StringEncoding error:nil];
    login_agent(agent);
    return agent;
}

static inline FHAgent *real_test_agent()
{
    FHAgent *agent = [FHAgent agentWithEmail:@"real@example.com" password:@"pw"];
    login_agent(agent);
    return agent;
}
