//
//  FHAgent.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/11/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "FHObject.h"

@class FHRemoteArray, FHCompany;


@interface FHAgent : FHObject

@property (nonatomic, copy            ) NSString     *accessToken;
@property (nonatomic, copy            ) NSString     *URLToken;

@property (nonatomic, copy            ) NSString     *firstName;
@property (nonatomic, copy            ) NSString     *lastName;
@property (nonatomic, copy            ) NSString     *email;

@property (nonatomic, copy,   readonly) NSOrderedSet *companies;            // Array of FHCompany objects
@property (nonatomic, strong          ) FHCompany    *currentCompany;

// returns the cached agent with identifier. If not present, creates and caches it.
+ (FHAgent *)agentWithIdentifier:(NSNumber *)identifier;

// To create an agent in preparation for logging in via a stored access token
+ (FHAgent *)agentWithAccessToken:(NSString *)accessToken;

// set automatically by the login/signup system
+ (FHAgent *)loggedInAgent;

// Creating an agent in preparation for sign up
+ (FHAgent *)agentWithEmail:(NSString *)email password:(NSString *)password;

- (MTPocketRequest *)signupWithFirstName:(NSString *)firstName lastName:(NSString *)lastName;
- (MTPocketRequest *)login;
- (void)logout;
- (MTPocketRequest *)fetch;
- (MTPocketRequest *)save;
- (MTPocketRequest *)destroy;
- (MTPocketRequest *)dismissNotifications:(NSOrderedSet *)notifications;

- (void)setPassword:(NSString *)password;
- (NSString *)fullName;

@end
