//
//  FHClient.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/14/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//
#import <MTPocket.h>
#import "constants.h"


typedef NS_ENUM(NSInteger, FHEnvironment) {
    FHEnvironmentLocal,
    FHEnvironmentTesting,
    FHEnvironmentTunnel,
    FHEnvironmentStaging,
    FHEnvironmentProduction
};


typedef NS_ENUM(NSInteger, FHServer) {
    FHServerAPI,
    FHServerBilling
};


@interface FHClient : MTPocket

@property (nonatomic, readonly) FHEnvironment environment;

+ (FHClient *)sharedClient;

- (void)setEnvironment:(FHEnvironment)environment;

- (MTPocketRequest *)requestToServer:(FHServer)server
                               route:(NSString *)route
                         identifiers:(NSArray *)identifiers           // NSNUmber
                              method:(MTPocketMethod)method
                                page:(NSInteger)page                  // Starts at 1. Pass 0 or -1 if you don't care.
                             perPage:(NSInteger)perPage
                              params:(NSDictionary *)params           // NSNumber or NSString
                                body:(id)body;


@end
