//
//  FHCustomer.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/15/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//
@class FHAgent;

#import "FHObject.h"
#import "FHRemoteArray.h"

@interface FHCustomer : FHObject 

@property (nonatomic, assign, readonly) FHCompany     *company;
@property (nonatomic, copy,   readonly) NSString      *name;
@property (nonatomic, copy,   readonly) NSString      *location;
@property (nonatomic, copy,   readonly) NSString      *timeZone;
@property (nonatomic, copy,   readonly) NSNumber      *newestInteractionIdentifier;
@property (nonatomic, copy,   readonly) NSString      *newestInteractionExcerpt;
@property (nonatomic, copy,   readonly) NSDate        *newestInteractionReceivedAt;

@property (nonatomic, copy,   readonly) NSOrderedSet  *customerAccounts;
@property (nonatomic, copy,   readonly) NSOrderedSet  *interactionFlaggedAgents;

@property (nonatomic, strong, readonly) FHRemoteArray *interactions;
@property (nonatomic, strong          ) FHAgent       *agentWithDibs;

+ (FHCustomer *)customerWithIdentifier:(NSNumber *)identifier;
- (MTPocketRequest *)fetch;
- (MTPocketRequest *)destroy;
- (MTPocketRequest *)resolveAllInteractions;

@end
