//
//  FHAccount.m
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/26/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "private.h"



@interface FHCustomerAccount ()
@property (nonatomic, assign, readwrite) FHCustomer *customer;
@end



@implementation FHCustomerAccount


+ (FHCustomerAccount *)customerAccountWithIdentifier:(NSNumber *)identifier customer:(FHCustomer *)customer
{
    FHCustomerAccount *customerAccount  = (FHCustomerAccount *)[self objectWithIdentifier:identifier];
    customerAccount.customer            = customer;
    return customerAccount;
}



#pragma mark - Protected

- (void)populateWithDictionary:(NSDictionary *)dictionary
{
    _username       = [FHObject importString:dictionary[@"username"]];
    _followingUs    = [FHObject importBool:dictionary[@"following_us"]];
    _imageURL       = [FHObject importURL:dictionary[@"image_url"]];
    _description    = [FHObject importString:dictionary[@"description"]];
    _followersCount = [FHObject importInteger:dictionary[@"followers_count"]];
    _channel        = [FHObject importEnum:dictionary[@"channel"] usingMap:[FHInteraction channelEnumMap]];

    [super populateWithDictionary:dictionary];
}


@end
