//
//  FHEmailAccount.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/26/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "FHObject.h"



typedef NS_ENUM(NSInteger, FHEmailAccountKind) {
    FHEmailAccountKindIMAP  = 0,
    FHEmailAccountKindPOP   = 1
};




@interface FHEmailAccount : FHObject

@property (nonatomic, assign, readonly) FHCompany          *company;
@property (nonatomic                  ) FHEmailAccountKind kind;
@property (nonatomic, copy            ) NSString           *server;
@property (nonatomic                  ) NSInteger          port;
@property (nonatomic, copy            ) NSString           *username;
@property (nonatomic, copy            ) NSString           *password;
@property (nonatomic                  ) BOOL               SSL;
@property (nonatomic                  ) BOOL               deleteFromServer;

+ (FHEmailAccount *)emailAccountForCompany:(FHCompany *)company
                                      kind:(FHEmailAccountKind)kind
                                    server:(NSString *)server
                                      port:(NSInteger)port
                                  username:(NSString *)username
                                  password:(NSString *)password
                                  usingSSL:(BOOL)SSL;
- (MTPocketRequest *)save;     // creates if no identifier is present, updates otherwise
- (MTPocketRequest *)destroy;

- (BOOL)guessFieldsFromEmail;

@end
