//
//  FHEmailInteraction.m
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/28/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "private.h"

@implementation FHEmailInteraction

- (id)init
{
    self = [super init];
    if (self) {
        _attachments = [NSMutableOrderedSet orderedSet];
    }
    return self;
}

#pragma mark - Protected

+ (FHEmailInteraction *)emailInteractionWithIdentifier:(NSNumber *)identifier
{
    return (FHEmailInteraction *)[self objectWithIdentifier:identifier];
}

- (void)populateWithDictionary:(NSDictionary *)dictionary
{
    NSDictionary *emailInteractionDict = dictionary[@"email_interaction"];
    _emailSubject   = [FHObject importString:emailInteractionDict[@"subject"]];
    _replyTo        = [FHObject importString:emailInteractionDict[@"reply_to"]];
    _toEmail        = [FHObject importString:emailInteractionDict[@"to_email"]];
    _fromEmail      = [FHObject importString:emailInteractionDict[@"from_email"]];

    [self populateAssociatedObjects:&_attachments withDictionaries:emailInteractionDict[@"attachments"] createObjectBlock:^id(NSDictionary *dict) {
        return [FHAttachment attachmentWithIdentifier:dict[@"id"] emailInteraction:self];
    }];

    [super populateWithDictionary:dictionary];
}


@end
