//
//  FHFacebookAccount.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/26/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "FHObject.h"

@interface FHFacebookAccount : FHObject

@property (nonatomic, assign, readonly) FHCompany    *company;
@property (nonatomic, copy,   readonly) NSString     *username;
@property (nonatomic, copy,   readonly) NSNumber     *facebookUserId;
@property (nonatomic, copy,   readonly) NSURL        *imageURL;
@property (nonatomic, copy,   readonly) NSString     *name;

@property (nonatomic, copy,   readonly) NSOrderedSet *facebookPages;

/**
 Create a URL Scheme for your application and when the user wants to add a new Facebook account,
 call this method to obtain the oauth url and open it in the device's browser. Once the oauth process
 is complete, they will be redirect back to your application and if the authorization was sucessful,
 if you refresh the companies facebookAccounts association, the new account will be present.
 company: the company you want to add the new facebook account to.
 callback: The url of your application so that it will be reopened once the oauth process is complete (e.g. @"firehose://")
 */
+ (NSURL *)OAuthURLForCompany:(FHCompany *)company withCallback:(NSString *)callback;

- (MTPocketRequest *)destroy;

@end
