//
//  FHFacebookPage.m
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/26/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "private.h"


@interface FHFacebookPage ()
@property (assign, readwrite, nonatomic) FHFacebookAccount *facebookAccount;
@end



@implementation FHFacebookPage


- (MTPocketRequest *)save
{
    assert(self.identifier != nil);

    NSDictionary *body = @{ @"facebook_page" : [self exportDictionary] };

    MTPocketRequest *request = [[FHClient sharedClient] requestToServer:FHServerAPI
                                                                  route:@"facebook_pages/:id"
                                                            identifiers:@[self.identifier]
                                                                 method:MTPocketMethodPUT
                                                                   page:-1
                                                                perPage:-1
                                                                 params:nil
                                                                   body:body];
    return request;
}



#pragma mark - Protected

+ (FHFacebookPage *)facebookPageWithIdentifier:(NSNumber *)identifier facebookAccount:(FHFacebookAccount *)facebookAccount
{
    FHFacebookPage *page = (FHFacebookPage *)[self objectWithIdentifier:identifier];
    page.facebookAccount = facebookAccount;
    return page;
}

- (void)populateWithDictionary:(NSDictionary *)dictionary
{
    _name       = [FHObject importString:dictionary[@"name"]];
    _category   = [FHObject importString:dictionary[@"category"]];
    _pageId     = [FHObject importNumber:dictionary[@"page_id"]];
    _active     = [FHObject importBool:dictionary[@"active"]];
    [super populateWithDictionary:dictionary];
}

- (NSDictionary *)exportDictionary
{
    [self exportBool:_active as:@"active"];
    return [super exportDictionary];
}

@end
