//
//  FHNotification.m
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/26/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "private.h"



@interface FHNotification ()
@property (nonatomic, assign, readwrite) FHCompany *company;
@end




@implementation FHNotification


+ (FHNotification *)notificationWithIdentifier:(NSNumber *)identifier company:(FHCompany *)company
{
    FHNotification *notification    = (FHNotification *)[self objectWithIdentifier:identifier];
    notification.company            = company;
    return notification;
}




#pragma mark - Protected

- (void)populateWithDictionary:(NSDictionary *)dictionary
{
    _title  = [FHObject importString:dictionary[@"title"]];
    _text   = [FHObject importString:dictionary[@"text"]];
    _level  = [FHObject importEnum:dictionary[@"level"] usingMap:[FHNotification notificationLevelEnumMap]];

    [super populateWithDictionary:dictionary];
}

+ (NSDictionary *)notificationLevelEnumMap
{
    return @{
             @"info"       : @(FHNotificationLevelInfo),
             @"warning"    : @(FHNotificationLevelWarning),
             @"error"      : @(FHNotificationLevelError)
             };
}


@end
