//
//  FHResults.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/14/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

@protocol FHRemoteArrayObject;


@interface FHRemoteArray : NSMutableOrderedSet

@property (nonatomic, assign          ) NSInteger perPage;      // Default: -1, this deferes the default to the server
@property (nonatomic, assign          ) NSInteger page;         // Default: 1
@property (nonatomic, assign, readonly) NSInteger totalRows;    // After the first call of 'next' this will be populated with the total rows on the server.

- (MTPocketRequest *)next;                          // Fetches the next batch of objects, appends them to the results and increments the page.
- (void)empty;                                      // Empties the result set without resetting the page.
- (void)reset;                                      // Empties the result set and resets the page to 0.

@end
