//
//  FHTwitterAccount.h
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/26/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "FHObject.h"

@interface FHTwitterAccount : FHObject

@property (nonatomic, assign, readonly) FHCompany *company;
@property (nonatomic, copy,   readonly) NSString  *screenName;
@property (nonatomic, copy,   readonly) NSNumber  *twitterUserId;
@property (nonatomic, copy,   readonly) NSURL     *imageURL;

/**
 Create a URL Scheme for your application and when the user wants to add a new Twitter account,
 call this method to obtain the oauth url and open it in the device's browser. Once the oauth process
 is complete, they will be redirect back to your application and if the authorization was sucessful, 
 if you refresh the companies twitterAccounts association, the new account will be present.
 company: the company you want to add the new twitter account to.
 callback: The url of your application so that it will be reopened once the oauth process is complete (e.g. @"firehose://")
*/
+ (NSURL *)OAuthURLForCompany:(FHCompany *)company withCallback:(NSString *)callback;

- (MTPocketRequest *)destroy;

@end
