//
//  FHTwitterInteraciton.m
//  FirehoseCocoa
//
//  Created by Adam Kirk on 1/28/13.
//  Copyright (c) 2013 Mysterious Trousers. All rights reserved.
//

#import "private.h"

@implementation FHTwitterInteraction



#pragma mark - Protected

+ (FHTwitterInteraction *)twitterInteractionWithIdentifier:(NSNumber *)identifier
{
    return (FHTwitterInteraction *)[self objectWithIdentifier:identifier];
}

- (void)populateWithDictionary:(NSDictionary *)dictionary
{
    NSDictionary *twitterInteractionDict = dictionary[@"twitter_interaction"];
    _favorited              = [FHObject importBool:twitterInteractionDict[@"favorited"]];
    _tweetId                = [FHObject importNumber:twitterInteractionDict[@"tweet_id"]];
    _inReplyToScreenName    = [FHObject importString:twitterInteractionDict[@"in_reply_to_screen_name"]];
    _inReplyToStatusId      = [FHObject importNumber:twitterInteractionDict[@"in_reply_to_status_id"]];
    _retweetCount           = [FHObject importInteger:twitterInteractionDict[@"retweet_count"]];
    _tweetSource            = [FHObject importString:twitterInteractionDict[@"tweet_source"]];
    _toUserId               = [FHObject importNumber:twitterInteractionDict[@"to_user_id"]];
    _toScreenName           = [FHObject importString:twitterInteractionDict[@"twitter_account"][@"screen_name"]];
    _fromUserId             = [FHObject importNumber:twitterInteractionDict[@"from_user_id"]];

    [super populateWithDictionary:dictionary];
}


@end
